
var tocHeadersArray = new Array(6);
var currentHeaderLevel = 0;
var readonly = false;

function Startup()
{
  if (!InitEditorShell())
    return;

  for (var i=0; i<6; i++)
    tocHeadersArray[i] = [ "", "" ];

  for (var i=1; i<7; i++) {
    var menulist = document.getElementById("header"+i+"Menulist");
    var menuitem = document.getElementById("header"+i+"none");
    var textbox  = document.getElementById("header"+i+"Class");
    menulist.selectedItem = menuitem;
    textbox.setAttribute("disabled", "true");
  }

  var theDocument = window.editorShell.editorDocument;
  var toc = theDocument.getElementById("mozToc");
  var headers = "h1 1 h2 2 h3 3 h4 4 h5 5 h6 6";
  if (toc) {
    if (toc.style.getPropertyValue("-moz-user-select") == "none") {
      var checkbox = document.getElementById("readOnlyCheckbox");
      checkbox.checked = true;
      readonly = true;
    }
    var nodeList = toc.childNodes;
    for (var i=0; i< nodeList.length; i++) {
      if (nodeList.item(i).nodeType == Node.COMMENT_NODE) {
        if (nodeList.item(i).data.substr(0,6) == "mozToc") {
          headers = nodeList.item(i).data.substr(7,nodeList.item(i).length - 7);
          break;
        }
      }
    }
  }

  var headersArray = headers.split(" ");
  for (var i=0; i<headersArray.length; i+=2) {
    var tag = headersArray[i], className="";
    var index = headersArray[i+1];
    var menulist = document.getElementById("header"+index+"Menulist");
    if (menulist) {
      var sep = tag.indexOf(".");
      if (sep != -1) {
        var tmp   = tag.substr(0, sep);
        className = tag.substr(sep+1, tag.length - sep -1);
        tag = tmp;
      }
      var menuitem = document.getElementById("header"+index+tag.toUpperCase());
      var textbox  = document.getElementById("header"+index+"Class");
      menulist.selectedItem = menuitem;
      if (tag != "") {
        textbox.removeAttribute("disabled");
      }
      if (className != "") {
        textbox.value = className;
      }
      tocHeadersArray[index-1] = [ tag, className ];
    }
  }
}

function BuildTOC(update)
{
  function controlClass(node, index)
  {
    currentHeaderLevel = index+1;
    if (tocHeadersArray[index][1] == "") {
      return NodeFilter.FILTER_ACCEPT;
    }
    else if (node.getAttribute("class") != "") {
      var classArray = node.getAttribute("class").split(" ");
      for (var j=0; j<classArray.length; j++)
        if (classArray[j] == tocHeadersArray[index][1])
          return NodeFilter.FILTER_ACCEPT;
      return NodeFilter.FILTER_SKIP;
    }
    else
      return NodeFilter.FILTER_SKIP;
  }

  function FormControlFilter() 
  {
    this.acceptNode = function(node)
    {
      switch (node.nodeName.toLowerCase())
      {
        case tocHeadersArray[0][0]:
          return controlClass(node, 0);
          break;
        case tocHeadersArray[1][0]:
          return controlClass(node, 1);
          break;
        case tocHeadersArray[2][0]:
          return controlClass(node, 2);
          break;
        case tocHeadersArray[3][0]:
          return controlClass(node, 3);
          break;
        case tocHeadersArray[4][0]:
          return controlClass(node, 0);
          break;
        case tocHeadersArray[4][0]:
          return controlClass(node, 0);
          break;
        case tocHeadersArray[5][0]:
          return controlClass(node, 5);
          break;
        default:
          return NodeFilter.FILTER_SKIP;
          break;
      }
      return NodeFilter.FILTER_SKIP;   // placate the js compiler
    }     
  }
  var theDocument = window.editorShell.editorDocument;
  var filter = new FormControlFilter();
  var iterator = theDocument.createTreeWalker(theDocument.documentElement, NodeFilter.SHOW_ELEMENT, filter, true);
  var tocArray = new Array();
  if (iterator) {
    var foo = iterator.nextNode();
    while (foo) {
      var headerIndex = currentHeaderLevel;
      var textIt = theDocument.createTreeWalker(foo, NodeFilter.SHOW_TEXT, null, true);
      var bar = textIt.nextNode(), headerText = "";
      while (bar) {
        headerText += bar.data;
        bar = textIt.nextNode();
      }
      var anchor = foo.firstChild, id;
      if (anchor.nodeName.toLowerCase() == "a"
          && anchor.hasAttribute("name")
          && anchor.hasAttribute("class")
          && anchor.getAttribute("class").substr(0, 6) == "mozToc") {
        id = anchor.getAttribute("name");
      }
      else {
        anchor = theDocument.createElement("a");
        foo.insertBefore(anchor, foo.firstChild);
        var c = 1000000 * Math.random();
        id = "mozTocId" + Number(Math.round(c)).toString();
        anchor.setAttribute("name",  id);
        anchor.setAttribute("class", "mozToc" + foo.nodeName.toUpperCase());
      }
      tocArray.push(headerIndex, headerText, id);
      foo = iterator.nextNode();
    }
  }

  /* generate the TOC itself */
  var headerIndex = 0, item = null, toc;
  for (var i=0; i<tocArray.length; i++) {
    if (!headerIndex) {
      headerIndex++;
      toc = theDocument.getElementById("mozToc");
      if (!toc || !update) {
        toc = window.editorShell.CreateElementWithDefaults("ol");
        var pit = theDocument.createElement("li");
        toc.appendChild(pit);
        window.editorShell.InsertElementAtSelection(toc, true);
        toc.removeChild(pit);
        toc.setAttribute("id", "mozToc");
      }
      else {
        var nodeList = toc.childNodes, l=nodeList.length;
        for (j=l-1; j>=0; j--)
          toc.removeChild(nodeList.item(j));
      }
      var commentText = "mozToc ";
      for (var j=0; j<6; j++) {
        if (tocHeadersArray[j][0] != "") {
          commentText += tocHeadersArray[j][0];
          if (tocHeadersArray[j][1] != "") {
            commentText += "." + tocHeadersArray[j][1];
          }
          commentText += " " + (j+1) + " ";
        }
      }
      var ct = theDocument.createComment(commentText);
      toc.appendChild(ct);
      if (readonly) {
        toc.style.setProperty("-moz-user-input", "none", "!important");
        toc.style.setProperty("-moz-user-select", "none", "!important");
      }
      else {
        toc.style.removeProperty("-moz-user-input");
        toc.style.removeProperty("-moz-user-select");
      }      
      var tocList = toc;
      var tocItem = theDocument.createElement("li");
      var tocAnchor = theDocument.createElement("a");
      tocAnchor.setAttribute("href", "#"+tocArray[i+2]);
      var tocEntry = theDocument.createTextNode(tocArray[i+1]);
      tocAnchor.appendChild(tocEntry);
      tocItem.appendChild(tocAnchor);
      tocList.appendChild(tocItem);
      item = tocList;
      i += 2;
    }
    else {
      var tocItem;
      if (tocArray[i] < headerIndex) {
        for (var j=headerIndex-tocArray[i]; j>0; j--) {
          if (item != toc) {
            item = item.parentNode.parentNode;
          }
        }
        tocItem = theDocument.createElement("li");
      } else if (tocArray[i] > headerIndex) {
        var tocList;
        for (var j=tocArray[i]-headerIndex; j>0; j--) {
          tocList = theDocument.createElement("ol");
          item.lastChild.appendChild(tocList);
          tocItem = theDocument.createElement("li");
          tocList.appendChild(tocItem);
          item = tocList;
        }
      }
      else
        tocItem = theDocument.createElement("li");
      var tocAnchor = theDocument.createElement("a");
      tocAnchor.setAttribute("href", "#"+tocArray[i+2]);      
      var tocEntry = theDocument.createTextNode(tocArray[i+1]);
      tocAnchor.appendChild(tocEntry);
      tocItem.appendChild(tocAnchor);
      item.appendChild(tocItem);
      headerIndex = tocArray[i];
      i += 2;
    }
  }
  window.close();
}

function selectHeader(elt, index)
{
  var tag = elt.value;
  tocHeadersArray[index-1][0] = tag;
  var textbox = document.getElementById("header"+index+"Class");
  if (tag == "") {
    textbox.setAttribute("disabled", "true");
  }
  else {
    textbox.removeAttribute("disabled");
  }
}

function changeClass(elt, index)
{
  tocHeadersArray[index-1][1] = elt.value;
}

function OpenAbout()
{
  window.openDialog("chrome://tocmaker/content/aboutTOC.xul","_blank", "chrome,close,modal,titlebar");
  //window._content.focus();
}

function ToggleReadOnlyToc(elt)
{
  readonly = elt.checked;
}